import _regeneratorRuntime from 'babel-runtime/regenerator';
import { call, put } from 'redux-saga/effects';
import getFunctionName from 'fn-name';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _Symbol$iterator from 'babel-runtime/core-js/symbol/iterator';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import { createAction } from 'redux-actions';
import snakeCase from 'snake-case';

function generateWrappedFunctionName(functionWrapper, functionWrapped) {
  var overrideWrapped = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  var wrappedName = overrideWrapped || getFunctionName(functionWrapped);
  return getFunctionName(functionWrapper) + '(' + wrappedName + ')';
}

function construct(Class) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new (Function.prototype.bind.apply(Class, [null].concat(args)))();
  };
}

var Result = function () {
  function Result(value, error) {
    _classCallCheck(this, Result);

    this.ok = null;
    this.err = null;

    this.ok = value;
    this.err = error;
  }

  _createClass(Result, [{
    key: _Symbol$iterator,
    value: _regeneratorRuntime.mark(function value() {
      return _regeneratorRuntime.wrap(function value$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this.ok;

            case 2:
              _context.next = 4;
              return this.err;

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, value, this);
    })
  }, {
    key: "isOk",
    value: function isOk() {
      return this instanceof Ok;
    }
  }, {
    key: "isErr",
    value: function isErr() {
      return this instanceof Err;
    }
  }]);

  return Result;
}();

Result.Ok = Ok;
Result.Err = Err;
var Ok = function (_Result) {
  _inherits(Ok, _Result);

  function Ok(value) {
    _classCallCheck(this, Ok);

    return _possibleConstructorReturn(this, (Ok.__proto__ || _Object$getPrototypeOf(Ok)).call(this, value, null));
  }

  return Ok;
}(Result);

var Err = function (_Result2) {
  _inherits(Err, _Result2);

  function Err(error) {
    _classCallCheck(this, Err);

    return _possibleConstructorReturn(this, (Err.__proto__ || _Object$getPrototypeOf(Err)).call(this, null, error));
  }

  return Err;
}(Result);

function toResult(fn) {
  function wrapFunctionWithToResult() {
    return fn.apply(undefined, arguments).then(construct(Ok), construct(Err));
  }
  wrapFunctionWithToResult.displayName = generateWrappedFunctionName(wrapFunctionWithToResult, fn);
  return wrapFunctionWithToResult;
}

function createBooleanCallHandler(handleSuccess, handleError) {
  function wrapFunctionWithBooleanCallHandler(fn) {
    var _marked = [booleanCallHandler].map(_regeneratorRuntime.mark);

    function booleanCallHandler() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var result;
      return _regeneratorRuntime.wrap(function booleanCallHandler$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return call.apply(undefined, [toResult(fn)].concat(args));

            case 2:
              result = _context.sent;

              if (!result.isOk()) {
                _context.next = 8;
                break;
              }

              _context.next = 6;
              return call(handleSuccess, result.ok);

            case 6:
              _context.next = 10;
              break;

            case 8:
              _context.next = 10;
              return call(handleError, result.err);

            case 10:
              return _context.abrupt('return', result);

            case 11:
            case 'end':
              return _context.stop();
          }
        }
      }, _marked[0], this);
    }
    booleanCallHandler.displayName = generateWrappedFunctionName(booleanCallHandler, fn);
    return booleanCallHandler;
  }
  return wrapFunctionWithBooleanCallHandler;
}

function match(result) {
  return {
    // NOTE: The keys of toHandles are strings; if we need to match a specific
    //       error name then the error must have a string `name` property.
    as: function as() {
      var toHandles = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      if (!toHandles.Ok || !toHandles.Err) {
        throw new Error('match-as requires Ok and Err to be defined');
      }

      var handler = void 0,
          value = void 0;
      if (result.isOk()) {
        handler = toHandles.Ok;
        value = result.ok;
      } else {
        var defaultErrorHandler = toHandles.Err;
        handler = defaultErrorHandler;
        for (var handlerKey in toHandles) {
          if (handlerKey === 'Ok' || handlerKey === 'Err') {
            continue;
          }
          var errorToLookFor = handlerKey;
          var currentErrorName = result.err.name;
          if (currentErrorName === errorToLookFor) {
            handler = toHandles[handlerKey];
          }
        }
        value = result.err;
      }
      return call(handler, value);
    }
  };
}

function createMatchAsCallHandler() {
  var toHandles = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  function wrapFunctionWithMatchAsCallHandler(fn) {
    var _marked = [matchAsCallHandler].map(_regeneratorRuntime.mark);

    function matchAsCallHandler() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var result;
      return _regeneratorRuntime.wrap(function matchAsCallHandler$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return call.apply(undefined, [toResult(fn)].concat(args));

            case 2:
              result = _context.sent;
              _context.next = 5;
              return match(result).as(toHandles);

            case 5:
              return _context.abrupt('return', result);

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _marked[0], this);
    }
    matchAsCallHandler.displayName = generateWrappedFunctionName(matchAsCallHandler, fn);
    return matchAsCallHandler;
  }
  return wrapFunctionWithMatchAsCallHandler;
}

function generateDefaultCallName(fn) {
  return snakeCase(getFunctionName(fn)).toUpperCase() || 'CALL';
}

function toActionPutter(actionCreator) {
  var _marked = [actionPutter].map(_regeneratorRuntime.mark);

  function actionPutter(value) {
    return _regeneratorRuntime.wrap(function actionPutter$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return put(actionCreator(value));

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _marked[0], this);
  }
  actionPutter.displayName = generateWrappedFunctionName(actionPutter, actionCreator, '' + actionCreator);
  return actionPutter;
}

function createEmitActions(successAction, errorAction) {
  function emitActions(fn) {
    successAction = successAction || createAction(generateDefaultCallName(fn) + '_SUCCESS');
    errorAction = errorAction || createAction(generateDefaultCallName(fn) + '_ERROR');
    var booleanCallHandler = createBooleanCallHandler(toActionPutter(successAction), toActionPutter(errorAction));
    return booleanCallHandler(fn);
  }
  return emitActions;
}

var emitActions = createEmitActions();

export { createBooleanCallHandler, createMatchAsCallHandler, toActionPutter, createEmitActions, emitActions, toResult, Result, Ok, Err };export default emitActions;
//# sourceMappingURL=index.es.map
